# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define appdir %{_datadir}/%{name}
%define section free

Name:           jruby
Version:        1.3.1
Release:	2%{?dist}
Epoch:          0
Summary:        Pure Java implementation of the Ruby interpreter
License:        GPL/LGPL
URL:            http://jruby.codehaus.org
Group:          Development/Libraries/Java
Source0:        http://dist.codehaus.org/jruby/1.3.1/jruby-src-1.3.1.tar.gz
Source1:        http://repo1.maven.org/maven2/org/jruby/shared/1.3.1/shared-1.3.1.pom
Source2:        http://repo1.maven.org/maven2/org/jruby/jruby/1.3.1/jruby-1.3.1.pom
Source3:        http://repo1.maven.org/maven2/org/jruby/jruby-complete/1.3.1/jruby-complete-1.3.1.pom
Patch0:         jruby-build.patch
Patch1:         jruby-InvokeDynamicSupport.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant17 >= 0:1.7
BuildRequires:  ant17-junit
BuildRequires:  ant17-trax
BuildRequires:  emma
BuildRequires:  jarjar >= 0:0.6
BuildRequires:  junit
BuildRequires:  xalan-j2

BuildRequires:  objectweb-asm >= 0:3.0
BuildRequires:  backport-util-concurrent
BuildRequires:  bsf
BuildRequires:  constantine
BuildRequires:  jakarta-commons-logging
BuildRequires:  jay
BuildRequires:  jffi
BuildRequires:  jline >= 0:0.9.9.1
BuildRequires:  jna
BuildRequires:  jna-posix
BuildRequires:  joda-time >= 0:1.5.1
BuildRequires:  joni
BuildRequires:  jruby-bytelist
BuildRequires:  jvyamlb
BuildRequires:  nailgun
BuildRequires:  retroweaver
#BuildRequires:  jsr292-backport

Requires:       java >= 0:1.6.0
Requires:       objectweb-asm >= 0:3.0
Requires:       backport-util-concurrent
Requires:       bsf
Requires:       constantine
Requires:       jffi
Requires:       jline >= 0:0.9.9.1
Requires:       jpackage-utils >= 0:1.7.5
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JRuby is an 100% pure-Java implementation of the Ruby 
programming language.
Features:
- A 1.8.6 compatible Ruby interpreter written in 100% pure Java 
- Most builtin Ruby classes provided 
- Support for interacting with and defining java classes from within ruby 
- Bean Scripting Framework (BSF) support 
- Distributed under a tri-license (CPL/GPL/LGPL) 


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%package        demo
Summary:        Samples for %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    demo
%{summary}.

%prep
%setup -q
%patch0 -b .sav0

for j in $(find lib -name "*.jar"); do
    mv $j $j.no
done

for j in $(find build_lib -name "*.jar"); do
    mv $j $j.no
done
pushd build_lib
ln -sf $(build-classpath objectweb-asm/asm)
ln -sf $(build-classpath objectweb-asm/asm-analysis)
ln -sf $(build-classpath objectweb-asm/asm-commons)
ln -sf $(build-classpath objectweb-asm/asm-tree)
ln -sf $(build-classpath objectweb-asm/asm-util)
##ln -sf $(build-classpath aqute-bndlib) bnd.jar
ln -sf $(build-classpath bsf)
ln -sf $(build-classpath jruby-bytelist) bytelist.jar
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath constantine)
ln -sf $(build-classpath emma_ant)
ln -sf $(build-classpath emma)
ln -sf $(build-classpath jarjar)
ln -sf $(build-classpath jcodings)
#ln -sf $(build-classpath jffi-i386-Linux)
ln -sf $(build-classpath jffi)
ln -sf $(build-classpath jline)
##ln -sf $(build-classpath jna)
ln -sf $(build-classpath jna-posix)
ln -sf $(build-classpath joda-time)
ln -sf $(build-classpath joni)
ln -sf $(build-classpath junit)
ln -sf $(build-classpath jvyamlb)
ln -sf $(build-classpath jay-yydebug) yydebug.jar
ln -sf $(build-classpath nailgun) 
popd
#BUILD/jruby-1.3.1/build_lib/apt-mirror-api.jar.no
#BUILD/jruby-1.3.1/build_lib/bnd-0.0.249.jar.no
##BUILD/jruby-1.3.1/build_lib/dynalang-0.3.jar.no
##BUILD/jruby-1.3.1/build_lib/invokedynamic.jar.no
#BUILD/jruby-1.3.1/lib/profile.jar.no
mv build_lib/bnd-0.0.249.jar.no build_lib/bnd-0.0.249.jar
mv build_lib/invokedynamic.jar.no build_lib/invokedynamic.jar
#ln -sf $(build-classpath jsr292-backport) build_lib/invokedynamic.jar
mv build_lib/dynalang-0.3.jar.no build_lib/dynalang.jar
#mv build_lib/jna.jar.no build_lib/jna.jar
ln -sf $(build-classpath jna) build_lib/jna.jar
## this test fails with jsr292-backport:
#rm spec/compiler/skinnymethodadapter_spec.rb

%build
export ANT_OPTS="-Xmx1024m"
export OPT_JAR_LIST="ant17/ant17-trax ant17/ant17-junit jarjar junit xalan-j2-serializer"
ant17 emma jar jar-console jar-complete test create-apidocs

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 lib/%{name}.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 lib/%{name}-console.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{name}-console-%{version}.jar
install -m 644 lib/%{name}-complete.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{name}-complete-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-shared.pom
%add_to_maven_depmap org.jruby shared %{version} JPP %{name}-shared
install -m 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jruby jruby %{version} JPP %{name}
install -m 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-complete.pom
%add_to_maven_depmap org.jruby jruby-complete %{version} JPP %{name}-complete

# data
install -p -d -m 755 $RPM_BUILD_ROOT%{appdir}
install -p -d -m 755 $RPM_BUILD_ROOT%{appdir}/bin
cp -p bin/* $RPM_BUILD_ROOT%{appdir}/bin
rm $RPM_BUILD_ROOT%{appdir}/bin/*.bat
chmod a+x $RPM_BUILD_ROOT%{appdir}/bin/*
install -p -d -m 755 $RPM_BUILD_ROOT%{appdir}/lib
ln -sf %{_libdir}/ruby $RPM_BUILD_ROOT%{appdir}/lib
pushd $RPM_BUILD_ROOT%{appdir}/lib
ln -sf $(build-classpath objectweb-asm/asm)
ln -sf $(build-classpath objectweb-asm/asm-analysis)
ln -sf $(build-classpath objectweb-asm/asm-commons)
ln -sf $(build-classpath objectweb-asm/asm-tree)
ln -sf $(build-classpath objectweb-asm/asm-util)
ln -sf $(build-classpath backport-util-concurrent)
ln -sf $(build-classpath bsf)
ln -sf $(build-classpath jruby-bytelist) bytelist.jar
ln -sf $(build-classpath jline)
ln -sf %{_javadir}/jruby.jar jruby.jar
popd
install -p -d -m 755 $RPM_BUILD_ROOT%{appdir}/samples
perl -p -i -e \
's|filename = "./samples/java2.rb"|filename = "%{appdir}/samples/java2.rb"|' \
samples/java2.rb
cp -a samples/* $RPM_BUILD_ROOT%{appdir}/samples

## scripts
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
for f in bin/*; do
    cp $f  $RPM_BUILD_ROOT%{_bindir}/j$(basename ${f})
done
rm $RPM_BUILD_ROOT%{_bindir}/*.bat
rm $RPM_BUILD_ROOT%{_bindir}/*.rb
rm $RPM_BUILD_ROOT%{_bindir}/jspec*

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -a docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf docs/api

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p COPYING COPYING.CPL COPYING.GPL COPYING.LGPL README \
        $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/COPYING*
%doc %{_docdir}/%{name}-%{version}/README
%attr(0755,root,root) %{_bindir}/*
%{_javadir}/*.jar
%dir %{appdir}
%dir %{appdir}/bin
%attr(0755,root,root) %{appdir}/bin/*
%{appdir}/lib
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}
%dir %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}-%{version}/*

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/docs

%files demo
%defattr(0644,root,root,0755)
%{appdir}/samples

%changelog
* Mon Sep 27 2010 Ralph Apel <r.apel@r-apel.de> 1.3.1-2
- prefix scripts with j

* Sun Sep 26 2010 Ralph Apel <r.apel@r-apel.de> 1.3.1-1
- 1.3.1

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 1.1.1-3
- Auto rebuild for JPackage 5 in mock

* Mon Jun 30 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-2.jpp5
- Fix pom file names

* Fri Jun 27 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-1jpp
- Upgrade to 1.1.1
- Symlink ruby lib into JRUBY_HOME/lib

* Thu Jul 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-1jpp
- Upgrade to 1.0

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:0.7.0-4jpp
- Rebuild with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.7.0-3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:0.7.0-2jpp
- Upgrade to Ant 1.6.X

* Mon Mar 15 2004 David Walluck <david@anti-microsoft.org> 0:0.7.0-1jpp
- release
